/* ComponentInfoDialog.java - hades.manager.ComponentInfoDialog
 *
 * 
 * 10.03.01 - first version, extracted from Colibri ComponentInfo
 */


package hades.manager;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


public class ComponentInfoDialog {
 
  // gui components:
  private transient Frame      parent    = null;
  private  transient Dialog    dialog     = null;
  private transient TextField  tf_arch   = null;
  private transient Choice    ch_icon    = null;
  private transient TextField  tf_auth   = null;
  private transient TextArea  ta_desc    = null;
  private transient List       versList   = null;
  private transient List       fileList   = null;
  private transient Choice    ch_html   = null;
  private transient Choice    ch_type   = null;
  private transient Choice    ch_start   = null;
  private transient Choice    ch_init   = null;
  private transient Choice    ch_image   = null;
  private transient Button    bu_ok      = null;
  private transient Button    bu_cancel  = null;
  private transient Button    bu_add    = null;
  private transient Button    bu_remove  = null;

  private ComponentInfo clb = null;


  public void setComponentInfo( ComponentInfo clb ) {
    this.clb = clb;
  }

  public ComponentInfo getComponentInfo() {
    return this.clb;
  }



  /**
  * Creates a dialog frame containing all the specific
  * component information. The dialog is used to show
  * and to edit.
  *
  * @param   parent     parent frame
  * @param   modal     modal dialog?
  * @param   local     if the component local (editable)
  */
  public void showDialog(Frame parent, boolean modal, boolean local)
  { 
    this.parent = parent;
    Panel left = new Panel();
    Panel right = new Panel();
    dialog = new Dialog(parent, "Properties of "+ clb.getName(), modal);
    dialog.setLayout(new GridLayout(1,2));
    
    /* LayoutManager setzen */
    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints gridcon = new GridBagConstraints();
    Insets ins = new Insets(0,0,0,0);
    left.setLayout(gridbag);
    right.setLayout(gridbag);
    
    /* das Panel zusammensetzen */
    Label l_arch = new Label("Archive:");
    gridcon.fill         = GridBagConstraints.HORIZONTAL;
    gridcon.weightx       = 0.5;
    gridcon.weighty       = 0.0;
    gridcon.gridx        = 0;
    gridcon.gridy        = 0;
    gridcon.gridwidth    = 2;
    gridcon.gridheight   = 1;
    ins.top              = 5;
    ins.bottom          = 0;
    ins.left            = 5;
    ins.right             = 5;
    gridcon.insets      = ins;
    gridbag.setConstraints(l_arch,gridcon);
    left.add(l_arch);
    
    tf_arch = new TextField();
    gridcon.fill         = GridBagConstraints.HORIZONTAL;
    gridcon.weightx       = 0.5;
    gridcon.weighty       = 0.0;
    gridcon.gridx        = 0;
    gridcon.gridy        = 1;
    gridcon.gridwidth    = 2;
    gridcon.gridheight   = 1;
    ins.top              = 0;
    ins.bottom          = 5;
    ins.left            = 5;
    ins.right             = 5;
    gridcon.insets      = ins;
    gridbag.setConstraints(tf_arch,gridcon);
    left.add(tf_arch);
    tf_arch.setEnabled(local);
    
    Label l_type = new Label("Type:");
    gridcon.fill         = GridBagConstraints.HORIZONTAL;
    gridcon.weightx       = 0.5;
    gridcon.weighty       = 0.0;
    gridcon.gridx        = 0;
    gridcon.gridy        = 2;
    gridcon.gridwidth        = 2;
    gridcon.gridheight       = 1;
    ins.top            = 0;
    ins.bottom           = 5;
    ins.left            = 5;
    ins.right           = 5;
    gridcon.insets          = ins;
    gridbag.setConstraints(l_type,gridcon);
    left.add(l_type);
    
    ch_type = new Choice();
    gridcon.fill         = GridBagConstraints.HORIZONTAL;
    gridcon.weightx       = 0.5;
    gridcon.weighty       = 0.0;
    gridcon.gridx        = 0;
    gridcon.gridy        = 3;
    gridcon.gridwidth        = 2;
    gridcon.gridheight       = 1;
    ins.top            = 0;
    ins.bottom           = 5;
    ins.left            = 5;
    ins.right           = 5;
    gridcon.insets          = ins;
    gridbag.setConstraints(ch_type,gridcon);
    left.add(ch_type);
    ch_type.setEnabled(local);

    Label l_vers = new Label("Versions:");
    gridcon.fill         = GridBagConstraints.HORIZONTAL;
    gridcon.weightx       = 0.5;
    gridcon.weighty       = 0.0;
    gridcon.gridx        = 0;
    gridcon.gridy        = 4;
    gridcon.gridwidth    = 2;
    gridcon.gridheight   = 1;
    ins.top              = 5;
    ins.bottom          = 0;
    ins.left            = 5;
    ins.right             = 5;
    gridcon.insets      = ins;
    gridbag.setConstraints(l_vers,gridcon);
    left.add(l_vers);

    versList = new List(3);
    gridcon.fill         = GridBagConstraints.HORIZONTAL;
    gridcon.weightx       = 0.5;
    gridcon.weighty       = 0.0;
    gridcon.gridx        = 0;
    gridcon.gridy        = 5;
    gridcon.gridwidth    = 2;
    gridcon.gridheight   = 1;
    ins.top              = 0;
    ins.bottom          = 10;
    ins.left            = 5;
    ins.right             = 5;
    gridcon.insets      = ins;
    gridbag.setConstraints(versList,gridcon);
    left.add(versList);
    //versList.setEnabled(false);
    
    Label l_file = new Label("Files:");
    gridcon.fill         = GridBagConstraints.HORIZONTAL;
    gridcon.weightx       = 0.5;
    gridcon.weighty       = 0.0;
    gridcon.gridx        = 0;
    gridcon.gridy        = 6;
    gridcon.gridwidth    = 2;
    gridcon.gridheight   = 1;
    ins.top              = 5;
    ins.bottom          = 0;
    ins.left            = 5;
    ins.right             = 5;
    gridcon.insets      = ins;
    gridbag.setConstraints(l_file,gridcon);
    left.add(l_file);
    
    fileList = new List();
    gridcon.fill         = GridBagConstraints.BOTH;
    gridcon.weightx       = 0.5;
    gridcon.weighty       = 1.0;
    gridcon.gridx        = 0;
    gridcon.gridy        = 7;
    gridcon.gridwidth    = 2;
    gridcon.gridheight   = 1;
    ins.top              = 0;
    ins.bottom          = 3;
    ins.left            = 5;
    ins.right             = 5;
    gridcon.insets      = ins;
    gridbag.setConstraints(fileList,gridcon);
    left.add(fileList);
    fileList.setEnabled(local);
    
    bu_add = new Button("Add ...");
    gridcon.fill         = GridBagConstraints.HORIZONTAL;
    gridcon.weightx       = 0.25;
    gridcon.weighty       = 0.0;
    gridcon.gridx        = 0;
    gridcon.gridy        = 8;
    gridcon.gridwidth    = 1;
    gridcon.gridheight   = 1;
    ins.top              = 0;
    ins.bottom          = 5;
    ins.left            = 5;
    ins.right             = 5;
    gridcon.insets      = ins;
    gridbag.setConstraints(bu_add,gridcon);
    left.add(bu_add);
    bu_add.setEnabled(local);
    
    bu_remove = new Button("Remove");
    gridcon.fill         = GridBagConstraints.HORIZONTAL;
    gridcon.weightx       = 0.25;
    gridcon.weighty       = 0.0;
    gridcon.gridx        = 1;
    gridcon.gridy        = 8;
    gridcon.gridwidth    = 1;
    gridcon.gridheight   = 1;
    ins.top              = 0;
    ins.bottom          = 5;
    ins.left            = 5;
    ins.right             = 5;
    gridcon.insets      = ins;
    gridbag.setConstraints(bu_remove,gridcon);
    left.add(bu_remove);
    bu_remove.setEnabled(local);
    
    bu_ok = new Button("Save");
    gridcon.fill         = GridBagConstraints.HORIZONTAL;
    gridcon.weightx       = 0.25;
    gridcon.weighty       = 0.0;
    gridcon.gridx        = 0;
    gridcon.gridy        = 9;
    gridcon.gridwidth    = 1;
    gridcon.gridheight   = 1;
    ins.top              = 5;
    ins.bottom          = 5;
    ins.left            = 5;
    ins.right             = 5;
    gridcon.insets      = ins;
    gridbag.setConstraints(bu_ok,gridcon);
    left.add(bu_ok);
    bu_ok.setEnabled(local);
    
    bu_cancel = new Button("Cancel");
    gridcon.fill         = GridBagConstraints.HORIZONTAL;
    gridcon.weightx       = 0.25;
    gridcon.weighty       = 0.0;
    gridcon.gridx        = 1;
    gridcon.gridy        = 9;
    gridcon.gridwidth    = 1;
    gridcon.gridheight   = 1;
    ins.top              = 5;
    ins.bottom          = 5;
    ins.left            = 5;
    ins.right             = 5;
    gridcon.insets      = ins;
    gridbag.setConstraints(bu_cancel,gridcon);
    left.add(bu_cancel);
    
    Label l_start = new Label("Start:");
    gridcon.fill         = GridBagConstraints.HORIZONTAL;
    gridcon.weightx       = 0.5;
    gridcon.weighty       = 0.0;
    gridcon.gridx        = 1;
    gridcon.gridy        = 0;
    gridcon.gridwidth    = 1;
    gridcon.gridheight   = 1;
    ins.top              = 5;
    ins.bottom          = 0;
    ins.left            = 5;
    ins.right             = 5;
    gridcon.insets      = ins;
    gridbag.setConstraints(l_start,gridcon);
    right.add(l_start);
    
    ch_start = new Choice();
    gridcon.fill         = GridBagConstraints.HORIZONTAL;
    gridcon.weightx       = 0.5;
    gridcon.weighty       = 0.0;
    gridcon.gridx        = 1;
    gridcon.gridy        = 1;
    gridcon.gridwidth    = 1;
    gridcon.gridheight   = 1;
    ins.top              = 0;
    ins.bottom          = 5;
    ins.left            = 5;
    ins.right             = 5;
    gridcon.insets      = ins;
    gridbag.setConstraints(ch_start,gridcon);
    right.add(ch_start);
    ch_start.setEnabled(local);
    
    Label l_init = new Label("Init:");
    gridcon.fill         = GridBagConstraints.HORIZONTAL;
    gridcon.weightx       = 0.5;
    gridcon.weighty       = 0.0;
    gridcon.gridx        = 1;
    gridcon.gridy        = 2;
    gridcon.gridwidth    = 1;
    gridcon.gridheight   = 1;
    ins.top              = 5;
    ins.bottom          = 0;
    ins.left            = 5;
    ins.right             = 5;
    gridcon.insets      = ins;
    gridbag.setConstraints(l_init,gridcon);
    right.add(l_init);
    
    ch_init = new Choice();
    gridcon.fill         = GridBagConstraints.HORIZONTAL;
    gridcon.weightx       = 0.5;
    gridcon.weighty       = 0.0;
    gridcon.gridx        = 1;
    gridcon.gridy        = 3;
    gridcon.gridwidth    = 1;
    gridcon.gridheight   = 1;
    ins.top              = 0;
    ins.bottom          = 5;
    ins.left            = 5;
    ins.right             = 5;
    gridcon.insets      = ins;
    gridbag.setConstraints(ch_init,gridcon);
    right.add(ch_init);
    ch_init.setEnabled(local);
    
    Label l_icon = new Label("Icon:");
    gridcon.fill         = GridBagConstraints.HORIZONTAL;
    gridcon.weightx       = 0.5;
    gridcon.weighty       = 0.0;
    gridcon.gridx        = 1;
    gridcon.gridy        = 4;
    gridcon.gridwidth    = 1;
    gridcon.gridheight   = 1;
    ins.top              = 5;
    ins.bottom          = 0;
    ins.left            = 5;
    ins.right             = 5;
    gridcon.insets      = ins;
    gridbag.setConstraints(l_icon,gridcon);
    right.add(l_icon);
    
    ch_icon = new Choice();
    gridcon.fill         = GridBagConstraints.HORIZONTAL;
    gridcon.weightx       = 0.5;
    gridcon.weighty       = 0.0;
    gridcon.gridx        = 1;
    gridcon.gridy        = 5;
    gridcon.gridwidth    = 1;
    gridcon.gridheight   = 1;
    ins.top              = 0;
    ins.bottom          = 5;
    ins.left            = 5;
    ins.right             = 5;
    gridcon.insets      = ins;
    gridbag.setConstraints(ch_icon,gridcon);
    right.add(ch_icon);
    ch_icon.setEnabled(local);
    
    Label l_image = new Label("Image:");
    gridcon.fill         = GridBagConstraints.HORIZONTAL;
    gridcon.weightx       = 0.5;
    gridcon.weighty       = 0.0;
    gridcon.gridx        = 1;
    gridcon.gridy        = 6;
    gridcon.gridwidth    = 1;
    gridcon.gridheight   = 1;
    ins.top              = 5;
    ins.bottom          = 0;
    ins.left            = 5;
    ins.right             = 5;
    gridcon.insets      = ins;
    gridbag.setConstraints(l_image,gridcon);
    right.add(l_image);
    
    ch_image = new Choice();
    gridcon.fill         = GridBagConstraints.HORIZONTAL;
    gridcon.weightx       = 0.5;
    gridcon.weighty       = 0.0;
    gridcon.gridx        = 1;
    gridcon.gridy        = 7;
    gridcon.gridwidth    = 1;
    gridcon.gridheight   = 1;
    ins.top              = 0;
    ins.bottom          = 5;
    ins.left            = 5;
    ins.right             = 5;
    gridcon.insets      = ins;
    gridbag.setConstraints(ch_image,gridcon);
    right.add(ch_image);
    ch_image.setEnabled(local);
    
    Label l_auth = new Label("Author:");
    gridcon.fill         = GridBagConstraints.HORIZONTAL;
    gridcon.weightx       = 0.5;
    gridcon.weighty       = 0.0;
    gridcon.gridx        = 1;
    gridcon.gridy        = 8;
    gridcon.gridwidth    = 1;
    gridcon.gridheight   = 1;
    ins.top              = 5;
    ins.bottom          = 0;
    ins.left            = 5;
    ins.right             = 5;
    gridcon.insets      = ins;
    gridbag.setConstraints(l_auth,gridcon);
    right.add(l_auth);
    
    tf_auth = new TextField();
    gridcon.fill         = GridBagConstraints.HORIZONTAL;
    gridcon.weightx       = 0.5;
    gridcon.weighty       = 0.0;
    gridcon.gridx        = 1;
    gridcon.gridy        = 9;
    gridcon.gridwidth    = 1;
    gridcon.gridheight   = 1;
    ins.top              = 0;
    ins.bottom          = 5;
    ins.left            = 5;
    ins.right             = 5;
    gridcon.insets      = ins;
    gridbag.setConstraints(tf_auth,gridcon);
    right.add(tf_auth);
    tf_auth.setEnabled(local);

    Label l_desc = new Label("Description:");
    gridcon.fill         = GridBagConstraints.HORIZONTAL;
    gridcon.weightx       = 0.5;
    gridcon.weighty       = 0.0;
    gridcon.gridx        = 1;
    gridcon.gridy        = 10;
    gridcon.gridwidth    = 1;
    gridcon.gridheight   = 1;
    ins.top              = 5;
    ins.bottom          = 0;
    ins.left            = 5;
    ins.right             = 5;
    gridcon.insets      = ins;
    gridbag.setConstraints(l_desc,gridcon);
    right.add(l_desc);
    
    ta_desc = new TextArea();
    gridcon.fill         = GridBagConstraints.BOTH;
    gridcon.weightx       = 0.5;
    gridcon.weighty       = 1.0;
    gridcon.gridx        = 1;
    gridcon.gridy        = 11;
    gridcon.gridwidth    = 1;
    gridcon.gridheight   = 1;
    ins.top              = 0;
    ins.bottom          = 5;
    ins.left            = 5;
    ins.right             = 5;
    gridcon.insets      = ins;
    gridbag.setConstraints(ta_desc,gridcon);
    right.add(ta_desc);
    ta_desc.setEnabled(local);


    Label l_html = new Label("HTML:");
    gridcon.fill         = GridBagConstraints.HORIZONTAL;
    gridcon.weightx     = 0.5;
    gridcon.weighty     = 0.0;
    gridcon.gridx        = 1;
    gridcon.gridy        = 12;
    gridcon.gridwidth    = 1;
    gridcon.gridheight   = 1;
    ins.top              = 5;
    ins.bottom          = 0;
    ins.left            = 5;
    ins.right             = 5;
    gridcon.insets      = ins;
    gridbag.setConstraints(l_html,gridcon);
    right.add(l_html);
    
    ch_html = new Choice();
    gridcon.fill         = GridBagConstraints.HORIZONTAL;
    gridcon.weightx     = 0.5;
    gridcon.weighty     = 0.0;
    gridcon.gridx        = 1;
    gridcon.gridy        = 13;
    gridcon.gridwidth    = 1;
    gridcon.gridheight  = 1;
    ins.top              = 0;
    ins.bottom          = 5;
    ins.left            = 5;
    ins.right           = 5;
    gridcon.insets      = ins;
    gridbag.setConstraints(ch_html,gridcon);
    right.add(ch_html);

// XXX

    if (clb.getArchive()!=null) tf_arch.setText( clb.getArchive() );

    if (clb.getAuthor() !=null) tf_auth.setText( clb.getAuthor() );

    //for (int i=0; i<vers.size(); i++)
    //  versList.add((String)vers.elementAt(i));

    for (int i=0; i<clb.getFiles().size(); i++)
      fileList.add((String)clb.getFiles().elementAt(i));
    
    ch_type.add("beans/");
    //    ch_type.add("beans/design");
    //    ch_type.add("beans/simobject");
    ch_type.add("activex/");
    ch_type.add("opendoc/");
    ch_type.select(clb.getType()+"/");
    //    ch_type.select(getType()+"/"+getSubtype());
    
    ch_start.add("<none>");
    ch_start.add("hades.models.Design");
    ch_start.add("hades.models.fsm.FsmWrapper");
    ch_start.add("hades.models.meta.KvdWrapper");
    for (int i=0; i<clb.getFiles().size(); i++)
    {
      String s = (String)clb.getFiles().elementAt(i);
      if (s.endsWith(".class"))
        ch_start.add(s.substring(0, s.length()-6).replace('/', '.'));
    }
    if (clb.getStart()!=null) ch_start.select( clb.getStart() );
    
    ch_init.add("<none>");
    for (int i=0; i< clb.getFiles().size(); i++)
    {
      String s = (String) clb.getFiles().elementAt(i);
      if (!s.endsWith(".class"))
        ch_init.add(s);
    }
    if ( clb.getInit() !=null) ch_init.select( clb.getInit() );
    
    for (int i=0; i< clb.getFiles().size(); i++)
    {
      String ent = (String) clb.getFiles().elementAt(i);
        if(
        ent.endsWith(".gif")||
        ent.endsWith(".jpg")||
        ent.endsWith(".jpeg")||
        ent.endsWith(".png")||
        ent.endsWith(".bmp")) 
          ch_icon.add(ent);
    }
    ch_icon.add("<none>");
    {
      // no icon directory available
      ch_icon.add("default.gif");
      ch_icon.add("simobj.gif");
      ch_icon.add("hds.gif");
      ch_icon.add("fsm.gif");
      ch_icon.add("kvd.gif");
      ch_icon.add("ic.gif");
      ch_icon.add("bean.gif");
      ch_icon.add("activex.gif");
      ch_icon.add("opendoc.gif");
    }
    if ( clb.getIconpath() !=null) ch_icon.select( clb.getIconpath() );
    
    ch_image.add("<none>");
    for (int i=0; i< clb.getFiles().size(); i++)
    {
      String ent = (String) clb.getFiles().elementAt(i);
        if(
        ent.endsWith(".gif")||
        ent.endsWith(".jpg")||
        ent.endsWith(".jpeg")||
        ent.endsWith(".png")||
        ent.endsWith(".bmp")) 
          ch_image.add(ent);
    }
    if ( clb.getImagepath() !=null) ch_image.select( clb.getImagepath() );
    
    if ( clb.getDescription() !=null) ta_desc.setText( clb.getDescription() );

    ch_html.add("<none>");
    for (int i=0; i< clb.getFiles().size(); i++)
    {
      String ent = (String) clb.getFiles().elementAt(i);
        if(
        ent.endsWith(".html")||
        ent.endsWith(".htm"))
          ch_html.add(ent);
    }
    if ( clb.getHTML() !=null) ch_html.select( clb.getHTML() );

    
    dialog.add(left);
    dialog.add(right);
    
    DialogListener dl = new DialogListener();
    dialog.addWindowListener(dl);
    versList.addItemListener(dl);
    bu_ok.addActionListener(dl);
    bu_cancel.addActionListener(dl);
    bu_add.addActionListener(dl);
    bu_remove.addActionListener(dl);
    dialog.setSize(500,400);
    dialog.setVisible(true);
    dialog.setSize(500,400);
  }


  
  class DialogListener extends WindowAdapter
    implements ActionListener, ItemListener
  {
    public void windowClosing(WindowEvent e)
    {
      dialog.setVisible(false);
      dialog.dispose();
    }

    public void itemStateChanged(ItemEvent e)
    {
      if (e.getSource()==versList)
        versList.deselect(versList.getSelectedIndex());
    }

    public void actionPerformed(ActionEvent e)
    {
      if (e.getSource()==bu_ok)
      {
/*
        // Files
        clb.getFiles().removeAllElements();
        String[] fl = fileList.getItems();
        for (int i=0; i<fl.length; i++)
          clb.getFiles().addElement(fl[i].trim());
        // Type
        String s = ch_type.getSelectedItem();
        type = s.substring(0, s.indexOf('/'));
        //       subtype = s.substring(s.indexOf('/')+1);
        //       if (subtype.trim().equals("")) subtype=null;
        // Archive
        if (tf_arch.getText().trim().equals(""))
          archive = null;
        else
          archive = tf_arch.getText().trim();
        // Start
        if (ch_start.getSelectedItem().equals("<none>"))
          start = null;
        else
          start = ch_start.getSelectedItem();
        // Init
        if (ch_init.getSelectedItem().equals("<none>"))
          init = null;
        else
          init = ch_init.getSelectedItem();
        // Icon
        if (!ch_icon.getSelectedItem().trim().equals(icon))
        {
          if (ch_icon.getSelectedItem().trim().equals(""))
            icon = null;
          else
            icon = ch_icon.getSelectedItem().trim();
          loadIcon();
        }
        // Image
        if (!ch_image.getSelectedItem().equals(image))
        {
          if (ch_image.getSelectedItem().equals("<none>"))
            image = null;
          else
            image = ch_image.getSelectedItem();
          loadImage();
        }
        // Author
        if (tf_auth.getText().trim().equals(""))
          author = null;
        else
          author = tf_auth.getText().trim();
        // Description
        if (ta_desc.getText().trim().equals(""))
          description = null;
        else
          description = ta_desc.getText();
        // HTML
        if (!ch_html.getSelectedItem().equals(html))
        {
          if (ch_html.getSelectedItem().equals("<none>"))
            html = null;
          else
            html = ch_html.getSelectedItem();
        }



        dialog.setVisible(false);
        dialog.dispose();
        // to do: this will not work because the version is missing
        //Browser.getBrowser().removeFromCache(getURL());
        try
        {
          clb.saveComponentInfo();
        }
        catch (Throwable ex)
        {
          System.out.println("-E- ComponentInfo -> Couldn't save clb-file");
        }
*/
      }
      else if (e.getSource()==bu_cancel)
      {
        dialog.setVisible(false);
        dialog.dispose();
      }
      else if (e.getSource()==bu_remove)
      {
        String s = fileList.getSelectedItem();
        if (s!=null)
        {
          fileList.remove(s);
          if (s.endsWith(".class"))
            ch_start.remove(s.substring(0, s.length()-6).replace('/', '.'));
          else if (s.endsWith(".hds"))
            ch_start.remove(s);
          else if (s.endsWith(".html")||s.endsWith(".htm"))
            ch_html.remove(s);
          else
          {
            for (int i=0; i<ch_image.getItemCount();i++)
              if (ch_image.getItem(i).equals(s)) ch_image.remove(i);
          }
        }
      }
      else if (e.getSource()==bu_add)
      {
        String name = JOptionPane.showInputDialog("Which file do you wish to add?"); 
        if (name!=null)
        {
          fileList.add(name);
          ch_image.add(name);
          if (name.endsWith(".class"))
            ch_start.add(name.substring(0, name.length()-6).replace('/', '.'));
          else if (name.endsWith(".hds"))
            ch_start.add(name);
          else if (name.endsWith(".html")||name.endsWith(".htm"))
            ch_html.add(name);
        }

      }
    }
  }


  public static void main( String argv[] ) throws Exception {
    Frame frame = new Frame( "ComponentInfoDialog selftest" );
    frame.setSize( 500, 50 );
    frame.show();

    ComponentInfoDialog cied = new ComponentInfoDialog();
    cied.setComponentInfo( new ComponentInfo( argv[0] ) );
    cied.showDialog( frame, false, true );
  }  
}
