/* Hugo.java - test some JVM stuff for the DesignManager
 *
 * 26.02.01 - first version
 */

package hades.manager;

import java.io.File;
import java.util.*;
import java.util.zip.*;


class Hugo {






  /**
   * read the "java.class.path" system property, break its contents
   * into individual parts, and create a File for each entry.
   * Return an File array with those Files.
   */
  public static File[] getClasspathEntries() {
    String classPath = System.getProperty( "java.class.path", "." );
    StringTokenizer st = new StringTokenizer( classPath, File.pathSeparator );

    Vector tmp = new Vector();
    while (st.hasMoreTokens()) {
      tmp.addElement( st.nextToken() ); 
    }

    File[] files = new File[ tmp.size() ];
    for( int i=0; i < files.length; i++ ) {
      files[i] = new File( (String) tmp.elementAt(i) );
    }
    return files;
  }





  public static void msg( String s ) {
    System.out.println( s );
  }

  public static void main( String argv[] ) {
    msg( "selftest started..." );

    msg( "Classpath: " + System.getProperty( "java.class.path" ));
    msg( "Ext dir: " + System.getProperty( "java.ext.dirs" ));


    File[] cpEntries = getClasspathEntries();
    for( int i=0; i < cpEntries.length; i++ ) {
      msg( "" + i + " " + cpEntries[i] );
    }


    msg( "\n... now checking for ZIP files and listing them..." );
    for( int i=0; i < cpEntries.length; i++ ) {
      msg( "" + i + " " + cpEntries[i] );

      try {
        ZipFile zipfile = new ZipFile( cpEntries[i] );
        Enumeration e = zipfile.entries();
        while (e.hasMoreElements()) {
          ZipEntry ze = (ZipEntry) e.nextElement();
          msg( "--- " + ze.getName() + " " + ze.isDirectory() 
                      + " " + ze.getSize() );
        }
      }
      catch( Exception e ) {
        // nothing to do here
      }
    }

  }

}
